diff --git recipes/images/opencocon-image.bb recipes/images/opencocon-image.bb
new file mode 100644
index 0000000..0098e38
--- /dev/null
+++ recipes/images/opencocon-image.bb
@@ -0,0 +1,219 @@
+# This image is intended to provide a basic configuration that allows
+# you to access a newly flashed device over the network or via the
+# native console, and use ipkg to install (from feeds accessible via
+# the network) any further features you require into internal flash
+# memory or onto attached storage.
+
+# It should be as small as possible, while still achieving that goal.
+
+# The rationale for naming it 'base-image' is that this image is the
+# base upon which you can install any other functionality you desire.
+
+# See the end of this file for further rationale and policy regarding
+# the contents of this image, and the criteria which are used to make
+# decisions about adding and removing packages from this image.
+
+# Although it is only fully tested with the Angstrom distro, this
+# image is intended to be distro-agnostic.
+
+
+IMAGE_NAME = "${DISTRO_NAME}-${DISTRO_VERSION}-${MACHINE}"
+
+#IMAGE_PREPROCESS_COMMAND = "create_etc_timestamp"
+
+DISTRO_UPDATE_ALTERNATIVES ?= "${PREFERRED_PROVIDER_virtual/update-alternatives}"
+
+DISTRO_PACKAGE_MANAGER ?= "ipkg ipkg-collateral"
+ONLINE_PACKAGE_MANAGEMENT = "no"
+
+# FIXME: We need a distro-indendent way of specifying feed configs.
+# Once the RFC for the DISTRO_FEED_CONFIGS variable name is approved,
+# we can remove this default definition and set it in the distro config.
+#DISTRO_FEED_CONFIGS ?= "${ANGSTROM_FEED_CONFIGS}"
+
+
+RDEPENDS = " \
+	base-files \
+	base-passwd \
+	modutils-initscripts \
+	keymaps	\
+        uclibc \ 
+        uclibc-utils \
+        kernel \
+	kernel-image \
+        busybox \
+	busybox-rc \
+        opkg \
+	libgcc \
+	grub \
+	xserver-xorg \
+	dialog \
+	xf86-input-keyboard \
+	xf86-input-mouse \
+	xf86-input-evdev \
+	xf86-input-synaptics \
+	xf86-video-apm \
+	xf86-video-ati \
+	xf86-video-chips \
+	xf86-video-cirrus \
+	xf86-video-fbdev \
+	xf86-video-geode \
+	xf86-video-glint \
+	xf86-video-i128 \
+	xf86-video-i740 \
+	xf86-video-intel \
+	xf86-video-mach64 \
+	xf86-video-mga \
+	xf86-video-neomagic \
+	xf86-video-nv \
+	xf86-video-openchrome \
+	xf86-video-r128 \
+	xf86-video-s3 \
+	xf86-video-s3virge \
+	xf86-video-savage \
+	xf86-video-siliconmotion \
+	xf86-video-sis \
+	xf86-video-trident \
+	xf86-video-vesa \
+	xf86-video-nouveau \
+	libdrm \
+	libdrm-kms \
+	libdrm-drivers \
+	xserver-xorg-module-libint10 \
+	xserver-xorg-module-libwfb \
+	xserver-xorg-module-xaa \
+	xserver-xorg-multimedia-modules \
+	xserver-xorg-extension-dri \
+	xserver-xorg-extension-dri2 \
+	xserver-xorg-extension-glx \
+	mesa-dri \
+	xterm \
+	xauth \
+	encodings \
+	font-util \
+	xorg-minimal-fonts \
+	xkbdata \
+	xcursor-themes \
+	xinit \
+	freerdp \
+	pcmciautils \
+	usbutils \
+	util-linux-ng \
+	wireless-tools \
+	wpa-supplicant \
+"
+
+IMAGE_INSTALL = " \
+        base-files \
+        base-passwd \
+        modutils-initscripts \
+        keymaps \
+        uclibc \
+        kernel \
+        kernel-image \
+	libiconv \
+        busybox \
+	busybox-rc \
+        opkg \
+        grub \
+	libgcc \
+	xserver-xorg \
+	dialog \
+	initscripts \
+	xf86-input-keyboard \
+	xf86-input-mouse \
+	xf86-input-evdev \
+	xf86-input-synaptics \
+	xf86-video-apm \
+	xf86-video-ati \
+	xf86-video-chips \
+	xf86-video-cirrus \
+	xf86-video-fbdev \
+	xf86-video-geode \
+	xf86-video-glint \
+        xf86-video-i128 \
+        xf86-video-i740 \
+        xf86-video-intel \
+	xf86-video-mach64 \
+	xf86-video-mga \
+	xf86-video-neomagic \
+	xf86-video-nv \
+	xf86-video-openchrome \
+	xf86-video-r128 \
+	xf86-video-s3 \
+	xf86-video-s3virge \
+	xf86-video-savage \
+	xf86-video-siliconmotion \
+	xf86-video-sis \
+	xf86-video-trident \
+	xf86-video-vesa \
+        xf86-video-nouveau \
+        libdrm \
+        libdrm-kms \
+        libdrm-drivers \
+        xserver-xorg-module-libint10 \
+        xserver-xorg-module-libwfb \
+        xserver-xorg-module-xaa \
+        xserver-xorg-multimedia-modules \
+        xserver-xorg-extension-dri \
+        xserver-xorg-extension-dri2 \
+        xserver-xorg-extension-glx \
+	mesa-dri \
+	xterm \
+	xauth \
+	encodings \
+	font-util \
+	xcursor-themes \
+	xinit \
+	freerdp \
+        pcmciautils \
+        usbutils \
+        util-linux-ng \
+        wireless-tools \
+        wpa-supplicant \
+"
+
+
+IMAGE_BASENAME = "opencocon-image"
+#IMAGE_LINGUAS = ""
+
+
+IMAGE_FSTYPES += " tar.gz "
+
+
+inherit image
+
+# Key features of this image are:
+
+# 1) Must be able to mount attached storage devices like SD cards, CF
+# cards, internal disks, external USB disks, etc.  Should support
+# various filesystem choices, but ext2 at a minimum.  The rationale
+# for this is that you need storage to be able to install significant
+# new functionality.
+
+# 2) Must be able to boot from internal flash, or directly from a
+# filesystem stored on the attached storage.  The rationale for this
+# is that you will want to boot from attached storage instead of
+# messing around with ipkg-link.
+
+# Rationale and policy:
+
+# 'base-image' is the smallest possible image which allows you to ssh
+# into a device via it's native network interface, and install
+# packages from feeds across the network into internal flash or onto
+# an attached storage device.
+
+# It is "larger" than minimal-image (which is strictly only that which
+# is required to boot and get ssh access to the device, and nothing
+# else), but is "smaller" than console-image (which has a whole lot of
+# stuff in it which could easily be ipkg installed after boot rather
+# than being in the initial rootfs).
+
+# It is required to always be small enough to fit in the internal
+# flash rootfs partition of an NSLU2 (as an example of the smaller end
+# of flash sizes that OE supports), and features will be removed from
+# the image to ensure that this is always the case.  Any feature that
+# can be installed over the network using the package manager after
+# the first boot is always fair game for removal at any time, and
+# patches are welcome to make base-image as small as possible while
+# still retaining the ability to subsequently install that feature.
diff --git recipes/initscripts/initscripts-1.0/cocon486/mountall.sh recipes/initscripts/initscripts-1.0/cocon486/mountall.sh
new file mode 100755
index 0000000..c61eb67
--- /dev/null
+++ recipes/initscripts/initscripts-1.0/cocon486/mountall.sh
@@ -0,0 +1,46 @@
+#!/bin/sh
+#
+# mountall.sh	Mount all filesystems.
+#
+# Version:	@(#)mountall.sh  2.83-2  01-Nov-2001  miquels@cistron.nl
+#
+. /etc/default/rcS
+
+#
+# Mount local filesystems in /etc/fstab. For some reason, people
+# might want to mount "proc" several times, and mount -v complains
+# about this. So we mount "proc" filesystems without -v.
+#
+test "$VERBOSE" != no && echo "Mounting local filesystems..."
+mount -a 2>/dev/null
+
+#
+# We might have mounted something over /dev, see if /dev/initctl is there.
+#
+if test ! -p /dev/initctl
+then
+	rm -f /dev/initctl
+	mknod -m 600 /dev/initctl p
+fi
+# kill -USR1 1
+
+#
+# Execute swapon command again, in case we want to swap to
+# a file on a now mounted filesystem.
+#
+doswap=yes
+case "`uname -r`" in
+	2.[0123].*)
+		if grep -qs resync /proc/mdstat
+		then
+			doswap=no
+		fi
+		;;
+esac
+if test $doswap = yes
+then
+	swapon -a 2> /dev/null
+fi
+
+: exit 0
+
diff --git recipes/libxml/libxml2.inc recipes/libxml/libxml2.inc
index c3265c9..49fddaf 100644
--- recipes/libxml/libxml2.inc
+++ recipes/libxml/libxml2.inc
@@ -8,7 +8,7 @@ SRC_URI = "ftp://xmlsoft.org/libxml2/libxml2-${PV}.tar.gz;name=archive"
 S = "${WORKDIR}/${BPN}-${PV}"
 
 nolargefile = "${@base_contains('DISTRO_FEATURES', 'largefile', '', '-DNO_LARGEFILE_SOURCE', d)}"
-EXTRA_OEMAKE_append_libc-uclibc = "'CFLAGS=${CFLAGS} ${nolargefile}'"
+export CFLAGS += " ${nolargefile}"
 
 INC_PR = "r9"
 
diff --git recipes/linux-libc-headers/linux-libc-headers_2.6.35.bb recipes/linux-libc-headers/linux-libc-headers_2.6.35.bb
new file mode 100644
index 0000000..62a385b
--- /dev/null
+++ recipes/linux-libc-headers/linux-libc-headers_2.6.35.bb
@@ -0,0 +1,28 @@
+require linux-libc-headers.inc
+
+# untested for non nios2 systems
+DEFAULT_PREFERENCE = "-1"
+INHIBIT_DEFAULT_DEPS = "1"
+DEPENDS += "unifdef-native"
+PR = "r0"
+
+COMPATIBLE_TARGET_SYS = "."
+SRC_URI = "${KERNELORG_MIRROR}/pub/linux/kernel/v2.6/linux-${PV}.tar.bz2;name=kernel \
+          "
+
+SRC_URI[kernel.md5sum] = "091abeb4684ce03d1d936851618687b6"
+SRC_URI[kernel.sha256sum] = "18b2e2c336032e366c942622b77302cb05fc034fb19018f086a4ebc9ed41bfcf"
+
+S = "${WORKDIR}/linux-${PV}"
+
+do_configure() {
+	cd ${S}
+	oe_runmake allnoconfig ARCH=$ARCH
+}
+
+do_compile () {
+}
+
+do_install() {
+	oe_runmake headers_install INSTALL_HDR_PATH=${D}${exec_prefix} ARCH=$ARCH
+}
diff --git recipes/linux/linux-cocon486_2.6.35.bb recipes/linux/linux-cocon486_2.6.35.bb
new file mode 100644
index 0000000..ea9ea29
--- /dev/null
+++ recipes/linux/linux-cocon486_2.6.35.bb
@@ -0,0 +1,28 @@
+require linux.inc
+
+STABLEV = "13"
+PR = "r0"
+
+# Mark archs/machines that this kernel supports
+DEFAULT_PREFERENCE = "-1"
+DEFAULT_PREFERENCE_cocon486 = "1"
+# DEFAULT_PREFERENCE_cocon686 = "1"
+
+COMPATIBLE_MACHINE = "cocon486"
+
+SRC_URI = "${KERNELORG_MIRROR}/pub/linux/kernel/v2.6/longterm/v2.6.35/linux-2.6.35.${STABLEV}.tar.bz2;name=kernel \
+           file://defconfig \
+	   "
+
+S = "${WORKDIR}/linux-2.6.35.${STABLEV}"
+
+
+do_configure() {
+        install ${WORKDIR}/defconfig ${S}/.config
+        oe_runmake oldconfig
+}
+
+
+
+SRC_URI[kernel.md5sum] = "ff6c850159de960f26e010fba08f4d59"
+SRC_URI[kernel.sha256sum] = "44876a58875c1535dc2a92ef96d444b640a7f714bb1e6209577c91f0ccdfd870"
diff --git recipes/pam/libpam_1.1.1.bb recipes/pam/libpam_1.1.1.bb
index 09bc554..ba84123 100644
--- recipes/pam/libpam_1.1.1.bb
+++ recipes/pam/libpam_1.1.1.bb
@@ -33,7 +33,7 @@ UCLIBC_PATCHES = " file://Linux-PAM-1.1.0-uclibc.patch \
                    file://pam-no-innetgr.patch \
                  "
 
-SRC_URI_append_libc-uclibc = ${UCLIBC_PATCHES}
+SRC_URI += "${UCLIBC_PATCHES}"
 
 inherit autotools gettext
 
@@ -44,6 +44,9 @@ EXTRA_OECONF += " --includedir=${includedir}/security"
 
 PACKAGES_DYNAMIC += " libpam-meta pam-plugin-*"
 
+CFLAGS_append = " -lintl "
+LDFLAGS_append = " -lintl "
+
 python populate_packages_prepend () {
 	import os.path
 
diff --git recipes/pciutils/pciutils_3.1.2.bb recipes/pciutils/pciutils_3.1.2.bb
index 4a4ba6d..a1b0108 100644
--- recipes/pciutils/pciutils_3.1.2.bb
+++ recipes/pciutils/pciutils_3.1.2.bb
@@ -7,7 +7,8 @@ LICENSE = "GPLv2"
 DEPENDS = "zlib"
 
 SRC_URI = "ftp://ftp.kernel.org/pub/software/utils/pciutils/pciutils-${PV}.tar.bz2 \
-	   file://pciutils.patch "
+	   file://pciutils.patch \
+	"
 SRC_URI_append_nylon = "file://gcc-3-compatibility.patch "
 
 PARALLEL_MAKE = ""
diff --git recipes/sysstat/sysstat.inc recipes/sysstat/sysstat.inc
index 40b8730..39431a7 100644
--- recipes/sysstat/sysstat.inc
+++ recipes/sysstat/sysstat.inc
@@ -17,4 +17,5 @@ do_configure_prepend() {
 FILES_${PN} += "${libdir}/sa"
 
 TARGET_CC_ARCH += "${LDFLAGS}"
-LDFLAGS_append_libc-uclibc = " -lintl"
+#LDFLAGS_append_libc-uclibc = " -lintl"
+LDFLAGS_append = " -lintl"
diff --git recipes/tcp-wrappers/tcp-wrappers_7.6.bb recipes/tcp-wrappers/tcp-wrappers_7.6.bb
index a61bd5e..2615164 100644
--- recipes/tcp-wrappers/tcp-wrappers_7.6.bb
+++ recipes/tcp-wrappers/tcp-wrappers_7.6.bb
@@ -57,7 +57,6 @@ EXTRA_OEMAKE = "'CC=${CC}' \
 		'KILL_OPT=-DKILL_IP_OPTIONS' \
 		'UMASK=-DDAEMON_UMASK=022' \
 		'NETGROUP=${EXTRA_OEMAKE_NETGROUP}' \
-		'LIBS=-lnsl' \
 		'ARFLAGS=rv' \
 		'AUX_OBJ=weak_symbols.o' \
 		'TLI=' \
diff --git recipes/uclibc/uclibc_0.9.31.bb recipes/uclibc/uclibc_0.9.31.bb
index d93fcfc..278ba00 100644
--- recipes/uclibc/uclibc_0.9.31.bb
+++ recipes/uclibc/uclibc_0.9.31.bb
@@ -15,6 +15,11 @@ PROVIDES += "virtual/${TARGET_PREFIX}libc-for-gcc"
 
 SRC_URI += "file://uClibc.machine file://uClibc.distro \
 	    file://ldso_use_arm_dl_linux_resolve_in_thumb_mode.patch \
+	    file://uClibc-0.9.31-add-sock-cloexec.patch \
+	    file://uClibc-0.9.31-linuxthreads-errno-fix.patch \
+	    file://uClibc-0.9.31-dnslookup-use-after-free.patch \
+	    file://uClibc-0.9.31-add-bsd-endian-conversions.patch \
+	    file://uClibc-0.9.31-add-inotify-init1.patch \
 	   "
 
 #recent versions uclibc require real kernel headers
diff --git recipes/udev/acl_2.2.49.bb recipes/udev/acl_2.2.49.bb
index 7b68a12..5f709c8 100644
--- recipes/udev/acl_2.2.49.bb
+++ recipes/udev/acl_2.2.49.bb
@@ -22,6 +22,8 @@ do_configure_append() {
 
     # gettext hack
     echo "#define _(str) str" >> ${S}/include/config.h
+    echo "#define textdomain(D) ((void)0)" >> ${S}/include/config.h
+    echo "#define bindtextdomain(D,P) ((void)0)" >> ${S}/include/config.h
 }
 
 do_configure_prepend() {
diff --git recipes/udev/attr_2.4.44.bb recipes/udev/attr_2.4.44.bb
index 00aafce..57c7365 100644
--- recipes/udev/attr_2.4.44.bb
+++ recipes/udev/attr_2.4.44.bb
@@ -23,6 +23,9 @@ BBCLASSEXTEND = "native"
 do_configure_append() {
 	# gettext hack
 	echo "#define _(str) str" >> ${S}/include/config.h
+
+	echo "#define textdomain(D) ((void)0)" >> ${S}/include/config.h
+	echo "#define bindtextdomain(D,P) ((void)0)" >> ${S}/include/config.h
 }
 
 do_configure_prepend_libc-uclibc() {
diff --git recipes/util-linux-ng/util-linux-ng.inc recipes/util-linux-ng/util-linux-ng.inc
index 51f25b2..f46c417 100644
--- recipes/util-linux-ng/util-linux-ng.inc
+++ recipes/util-linux-ng/util-linux-ng.inc
@@ -72,9 +72,9 @@ EXTRA_OECONF = "--disable-use-tty-group --disable-makeinstall-chown \
 --enable-kill --enable-last --enable-mesg --enable-raw --enable-login-utils \
 --enable-arch --enable-init --enable-partx --enable-schedutils \
 --with-fsprobe=builtin --enable-libuuid --enable-libblkid \
---enable-fsck --enable-reset ${NATIVECONF}"
+--enable-fsck --enable-reset --disable-nls ${NATIVECONF}"
 
-LDFLAGS_append_libc-uclibc = "${@['',' -lintl'][bb.data.getVar('USE_NLS', d, 1) == 'yes']}"
+# LDFLAGS_append_libc-uclibc = "${@['  -lintl ',' -lintl'][bb.data.getVar('USE_NLS', d, 1) == 'yes']}"
 LDFLAGS_virtclass-native = "${BUILD_LDFLAGS}"
 
 S = "${WORKDIR}/util-linux-ng-${PV}${RC}"
diff --git recipes/util-linux-ng/util-linux-ng_2.18.bb recipes/util-linux-ng/util-linux-ng_2.18.bb
index f4d8c02..c5a186c 100644
--- recipes/util-linux-ng/util-linux-ng_2.18.bb
+++ recipes/util-linux-ng/util-linux-ng_2.18.bb
@@ -10,8 +10,9 @@ SRC_URI += "file://uclibc-compile.patch \
 
 # fallocate is glibc 2.10, fallocate64 is glibc 2.11
 # we need to disable it for older versions
-EXTRA_OECONF += "ac_cv_func_fallocate=no"
-EXTRA_OECONF_append_virtclass-native += "--disable-fallocate --disable-use-tty-group"
+EXTRA_OECONF += "ac_cv_func_fallocate=no  --without-libintl-prefix  "
+EXTRA_OECONF_append_virtclass-native += "--disable-fallocate --disable-use-tty-group "
+
 
 SRC_URI[archive.md5sum] = "2f5f71e6af969d041d73ab778c141a77"
 SRC_URI[archive.sha256sum] = "b8c5c07c763888aa712b4585393346667a00793127c54cef0470cfa456b031cc"
diff --git recipes/util-linux/util-linux.inc recipes/util-linux/util-linux.inc
index e1caf80..4728a36 100644
--- recipes/util-linux/util-linux.inc
+++ recipes/util-linux/util-linux.inc
@@ -32,6 +32,8 @@ RDEPENDS_${PN} = "util-linux-umount util-linux-swaponoff util-linux-losetup"
 
 CFLAGS_append = "${@base_contains('DISTRO_FEATURES', 'largefile', '-D_FILE_OFFSET_BITS=64', '', d)}"
 
+EXTRA_OECONF = "--enable-nls"
+
 do_compile () {
 	set -e
 	install ${WORKDIR}/MCONFIG ${S}/MCONFIG
diff --git recipes/xorg-driver/xf86-video-mga_1.4.13.bb recipes/xorg-driver/xf86-video-mga_1.4.13.bb
new file mode 100644
index 0000000..4703eda
--- /dev/null
+++ recipes/xorg-driver/xf86-video-mga_1.4.13.bb
@@ -0,0 +1,7 @@
+require xorg-driver-video.inc
+DESCRIPTION = "X.Org X server -- MGA display driver"
+PE = "1"
+PR = "${INC_PR}.0"
+
+SRC_URI[archive.md5sum] = "f967fb3e655f6f68aa3f495eaadcaac2"
+SRC_URI[archive.sha256sum] = "b657bd5fec4aade6396c683886739b7c8ce57924278bee0e36f13a966eeddff6"
diff --git recipes/xorg-driver/xf86-video-nouveau_git.bb recipes/xorg-driver/xf86-video-nouveau_git.bb
new file mode 100644
index 0000000..dba4158
--- /dev/null
+++ recipes/xorg-driver/xf86-video-nouveau_git.bb
@@ -0,0 +1,15 @@
+require xorg-driver-video.inc
+DESCRIPTION = "X.Org X server -- Nouveau Xorg driver for NVIDIA chips"
+DEPENDS += "libdrm"
+RDEPENDS_${PN} = "xserver-xorg-extension-dri xserver-xorg-extension-dri2 xserver-xorg-extension-glx mesa-dri"
+PE = "2"
+PV = "gitr${SRCPV}"
+PR = "${INC_PR}.5"
+
+SRC_URI = "git://anongit.freedesktop.org/nouveau/xf86-video-nouveau;protocol=git;branch=master \
+          "
+
+S = "${WORKDIR}/git"
+SRCREV = "aa2821a42706ac7b69703d1869e2d00a4ced9f4b"
+
+EXTRA_OECONF += " --enable-kms "
diff --git recipes/xorg-lib/pixman_0.21.6.bb recipes/xorg-lib/pixman_0.21.6.bb
index d5cc2c5..12f42a0 100644
--- recipes/xorg-lib/pixman_0.21.6.bb
+++ recipes/xorg-lib/pixman_0.21.6.bb
@@ -50,4 +50,5 @@ SRC_URI[sha256sum] = "ee22c24acc0c1b55a59aeeebfb3552038495d301e334608ac8e6af9817
 NEON = " --disable-arm-neon "
 NEON_armv7a = " "
 
-EXTRA_OECONF = "${NEON} --disable-gtk"
+EXTRA_OECONF = "${NEON} --disable-gtk "
+CFLAGS_append =" -DPIXMAN_NO_TLS "
diff --git site/common-uclibc site/common-uclibc
index 4a8557b..db66f71 100644
--- site/common-uclibc
+++ site/common-uclibc
@@ -26,3 +26,6 @@ ac_cv_func_posix_getpwnam_r=${ac_cv_func_posix_getpwnam_r=yes}
 
 # guile
 guile_cv_use_csqrt=${guile_cv_use_csqrt=no}
+
+# gettext
+gl_cv_func_unsetenv_works=${gl_cv_func_unsetenv_works=yes}
